<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.16"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>Zonzay: jchuff.h Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectlogo"><img alt="Logo" src="zonzay.png"/></td>
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">Zonzay
   &#160;<span id="projectnumber">1</span>
   </div>
   <div id="projectbrief">Laugh game challenge</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.16 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="dir_f6486992fdfcc735347cc2d407578037.html">FaceFilterSDK</a></li><li class="navelem"><a class="el" href="dir_80a4fd4d67846ee877317f9ddd7282cb.html">DlibWrapper</a></li><li class="navelem"><a class="el" href="dir_9b7b8713e4f43f3006d0cb3c779d469e.html">dlib</a></li><li class="navelem"><a class="el" href="dir_430f760fdc03f2637ab2743dbe6fb733.html">external</a></li><li class="navelem"><a class="el" href="dir_9f0d09b1dff431849d4e711f6a75743f.html">libjpeg</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="headertitle">
<div class="title">jchuff.h</div>  </div>
</div><!--header-->
<div class="contents">
<div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;<span class="comment">/*</span></div><div class="line"><a name="l00002"></a><span class="lineno">    2</span>&#160;<span class="comment"> * jchuff.h</span></div><div class="line"><a name="l00003"></a><span class="lineno">    3</span>&#160;<span class="comment"> *</span></div><div class="line"><a name="l00004"></a><span class="lineno">    4</span>&#160;<span class="comment"> * Copyright (C) 1991-1997, Thomas G. Lane.</span></div><div class="line"><a name="l00005"></a><span class="lineno">    5</span>&#160;<span class="comment"> * This file is part of the Independent JPEG Group&#39;s software.</span></div><div class="line"><a name="l00006"></a><span class="lineno">    6</span>&#160;<span class="comment"> * For conditions of distribution and use, see the accompanying README file.</span></div><div class="line"><a name="l00007"></a><span class="lineno">    7</span>&#160;<span class="comment"> *</span></div><div class="line"><a name="l00008"></a><span class="lineno">    8</span>&#160;<span class="comment"> * This file contains declarations for Huffman entropy encoding routines</span></div><div class="line"><a name="l00009"></a><span class="lineno">    9</span>&#160;<span class="comment"> * that are shared between the sequential encoder (jchuff.c) and the</span></div><div class="line"><a name="l00010"></a><span class="lineno">   10</span>&#160;<span class="comment"> * progressive encoder (jcphuff.c).  No other modules need to see these.</span></div><div class="line"><a name="l00011"></a><span class="lineno">   11</span>&#160;<span class="comment"> */</span></div><div class="line"><a name="l00012"></a><span class="lineno">   12</span>&#160; </div><div class="line"><a name="l00013"></a><span class="lineno">   13</span>&#160;<span class="comment">/* The legal range of a DCT coefficient is</span></div><div class="line"><a name="l00014"></a><span class="lineno">   14</span>&#160;<span class="comment"> *  -1024 .. +1023  for 8-bit data;</span></div><div class="line"><a name="l00015"></a><span class="lineno">   15</span>&#160;<span class="comment"> * -16384 .. +16383 for 12-bit data.</span></div><div class="line"><a name="l00016"></a><span class="lineno">   16</span>&#160;<span class="comment"> * Hence the magnitude should always fit in 10 or 14 bits respectively.</span></div><div class="line"><a name="l00017"></a><span class="lineno">   17</span>&#160;<span class="comment"> */</span></div><div class="line"><a name="l00018"></a><span class="lineno">   18</span>&#160; </div><div class="line"><a name="l00019"></a><span class="lineno">   19</span>&#160;<span class="preprocessor">#if BITS_IN_JSAMPLE == 8</span></div><div class="line"><a name="l00020"></a><span class="lineno">   20</span>&#160;<span class="preprocessor">#define MAX_COEF_BITS 10</span></div><div class="line"><a name="l00021"></a><span class="lineno">   21</span>&#160;<span class="preprocessor">#else</span></div><div class="line"><a name="l00022"></a><span class="lineno">   22</span>&#160;<span class="preprocessor">#define MAX_COEF_BITS 14</span></div><div class="line"><a name="l00023"></a><span class="lineno">   23</span>&#160;<span class="preprocessor">#endif</span></div><div class="line"><a name="l00024"></a><span class="lineno">   24</span>&#160; </div><div class="line"><a name="l00025"></a><span class="lineno">   25</span>&#160;<span class="comment">/* Derived data constructed for each Huffman table */</span></div><div class="line"><a name="l00026"></a><span class="lineno">   26</span>&#160; </div><div class="line"><a name="l00027"></a><span class="lineno"><a class="line" href="structc__derived__tbl.html">   27</a></span>&#160;<span class="keyword">typedef</span> <span class="keyword">struct </span>{</div><div class="line"><a name="l00028"></a><span class="lineno">   28</span>&#160;  <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> ehufco[256]; <span class="comment">/* code for each symbol */</span></div><div class="line"><a name="l00029"></a><span class="lineno">   29</span>&#160;  <span class="keywordtype">char</span> ehufsi[256];     <span class="comment">/* length of code for each symbol */</span></div><div class="line"><a name="l00030"></a><span class="lineno">   30</span>&#160;  <span class="comment">/* If no code has been allocated for a symbol S, ehufsi[S] contains 0 */</span></div><div class="line"><a name="l00031"></a><span class="lineno">   31</span>&#160;} <a class="code" href="structc__derived__tbl.html">c_derived_tbl</a>;</div><div class="line"><a name="l00032"></a><span class="lineno">   32</span>&#160; </div><div class="line"><a name="l00033"></a><span class="lineno">   33</span>&#160;<span class="comment">/* Short forms of external names for systems with brain-damaged linkers. */</span></div><div class="line"><a name="l00034"></a><span class="lineno">   34</span>&#160; </div><div class="line"><a name="l00035"></a><span class="lineno">   35</span>&#160;<span class="preprocessor">#ifdef NEED_SHORT_EXTERNAL_NAMES</span></div><div class="line"><a name="l00036"></a><span class="lineno">   36</span>&#160;<span class="preprocessor">#define jpeg_make_c_derived_tbl jMkCDerived</span></div><div class="line"><a name="l00037"></a><span class="lineno">   37</span>&#160;<span class="preprocessor">#define jpeg_gen_optimal_table  jGenOptTbl</span></div><div class="line"><a name="l00038"></a><span class="lineno">   38</span>&#160;<span class="preprocessor">#endif </span><span class="comment">/* NEED_SHORT_EXTERNAL_NAMES */</span><span class="preprocessor"></span></div><div class="line"><a name="l00039"></a><span class="lineno">   39</span>&#160; </div><div class="line"><a name="l00040"></a><span class="lineno">   40</span>&#160;<span class="comment">/* Expand a Huffman table definition into the derived format */</span></div><div class="line"><a name="l00041"></a><span class="lineno">   41</span>&#160;EXTERN(<span class="keywordtype">void</span>) jpeg_make_c_derived_tbl</div><div class="line"><a name="l00042"></a><span class="lineno">   42</span>&#160;    JPP((<a class="code" href="structjpeg__compress__struct.html">j_compress_ptr</a> cinfo, <span class="keywordtype">int</span> isDC, <span class="keywordtype">int</span> tblno,</div><div class="line"><a name="l00043"></a><span class="lineno">   43</span>&#160;         <a class="code" href="structc__derived__tbl.html">c_derived_tbl</a> ** pdtbl));</div><div class="line"><a name="l00044"></a><span class="lineno">   44</span>&#160; </div><div class="line"><a name="l00045"></a><span class="lineno">   45</span>&#160;<span class="comment">/* Generate an optimal table definition given the specified counts */</span></div><div class="line"><a name="l00046"></a><span class="lineno">   46</span>&#160;EXTERN(<span class="keywordtype">void</span>) jpeg_gen_optimal_table</div><div class="line"><a name="l00047"></a><span class="lineno">   47</span>&#160;    JPP((<a class="code" href="structjpeg__compress__struct.html">j_compress_ptr</a> cinfo, <a class="code" href="struct_j_h_u_f_f___t_b_l.html">JHUFF_TBL</a> * htbl, <span class="keywordtype">long</span> freq[]));</div></div><!-- fragment --></div><!-- contents -->
<div class="ttc" id="astructc__derived__tbl_html"><div class="ttname"><a href="structc__derived__tbl.html">c_derived_tbl</a></div><div class="ttdef"><b>Definition:</b> jchuff.h:27</div></div>
<div class="ttc" id="astructjpeg__compress__struct_html"><div class="ttname"><a href="structjpeg__compress__struct.html">jpeg_compress_struct</a></div><div class="ttdef"><b>Definition:</b> jpeglib.h:268</div></div>
<div class="ttc" id="astruct_j_h_u_f_f___t_b_l_html"><div class="ttname"><a href="struct_j_h_u_f_f___t_b_l.html">JHUFF_TBL</a></div><div class="ttdef"><b>Definition:</b> jpeglib.h:100</div></div>
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.16
</small></address>
</body>
</html>
